<!-- [QPRTemplateStart: jsportaltoolbarutils.tpl] -->
<#Include template="jsutils.tpl">

<script type="text/javascript">
var _sDefaultBookmarkName = "";

function sGetViewName()
{
  return "<#ViewName ENC="html">";
}

function OpenBookmarkEditor()
{
  var sUrl = sSetParameter(ACT_PARAM_NAM, sEncodeURI(_sDefaultBookmarkName), "<#AddBookmarkURL noname="1">");
  sUrl = sGetBookmarkURL(sUrl); // add dynamic state to bookmark URL
  OpenWindow(sUrl, "_blank", iGetBookmarkEditorWidth(), iGetBookmarkEditorHeight(), 0);
}

function sUpdateDefaultBookmarkName(vsDefaultBookmarkName, vbRecursing)
{
  var oFrameset;
  if (!vbRecursing) {
    oFrameset = oGetDetailsPaneFrameset(parent);
    if (!oFrameset || !oFrameset.sUpdateDefaultBookmarkName)
      oFrameset = oGetInformationViewFrame();
  }

 if (oFrameset && oFrameset.sUpdateDefaultBookmarkName)
   vsDefaultBookmarkName = oFrameset.sUpdateDefaultBookmarkName(vsDefaultBookmarkName, true);
  else {
    if (!vsDefaultBookmarkName) {
      if (!vsDefaultBookmarkName && (typeof(sGetBookmarkDefaultName) === "function"))
        vsDefaultBookmarkName = sGetBookmarkDefaultName();

      if (!vsDefaultBookmarkName && (typeof(sGetViewName) === "function")) {
        vsDefaultBookmarkName = sGetViewName();
        if (vsDefaultBookmarkName)
          vsDefaultBookmarkName = HTMLEscapeToURLEscape(vsDefaultBookmarkName);
      }

      if (!vsDefaultBookmarkName)
        vsDefaultBookmarkName = '<#ViewName ENC="url">';
    }
  }

  if (vsDefaultBookmarkName)
    _sDefaultBookmarkName = vsDefaultBookmarkName;

  return _sDefaultBookmarkName;
}

function sGetBookmarkButton(vsDefaultBookmarkName, vbExcludeTableCells)
{
  if (<#IsPortalReadonly true="true" false="false"> && !<#EnableBookmarksForViewUsers true="true" false="false">)
    return "";

  sUpdateDefaultBookmarkName(vsDefaultBookmarkName);

  var sHREF;
  if (bInPortal())
    sHREF = "javascript:oGetInformationView().OpenBookmarkEditor()";
  else
    sHREF = "javascript:OpenBookmarkEditor()";

  var sName = "<#LocalizedText id="Bookmark">";

  if (vbExcludeTableCells)
    return sGetButtonHTML(sName, sHREF);
  else
    return sGetToolbarIconButtonHTML(sName, sHREF, "<#PortalImageFileLocation>icon_star.png");
}

function sGetAlternateBookmarks()
{
  return sDecodeURI("<#AlternateBookmarks>");
}

function sGetBookmarkModelId()
{
  return sDecodeURI("<#BookmarkModelId>");
}

function sGetAddToBasketButton(vsDefaultBookmarkName, vbExcludeTableCells)
{
  if (<#HasRights product="portal" level="update" false="true" true="false">)
    return "";

  sUpdateDefaultBookmarkName(vsDefaultBookmarkName);

  var sHREF = "javascript:OpenWindow(\"<#VTNViewURL VTN="selectbasketitems" CRP="p">\", \"BasketView\", " + iGetBasketViewWidth() + ", " + iGetBasketViewHeight() + ")";
  var sName = "<#LocalizedText id="Add to Basket">";
  if (vbExcludeTableCells)
    return sGetButtonHTML(sName, sHREF);
  else
    return sGetToolbarIconButtonHTML(sName, sHREF, "<#PortalImageFileLocation>icon_add_to_basket.png");
}

function bGetBasketItems(AddView, AddDataItem, AddElement, AddBriefingItem)
{
  var oFrameset = oGetDetailsPaneFrameset(parent);
  if (oFrameset && oFrameset.bGetBasketItems)
    return oFrameset.bGetBasketItems(AddView, AddDataItem, AddElement, AddBriefingItem);
  return bGetBasketItemsEx(AddView, AddDataItem, AddElement, AddBriefingItem, "<#BasketItems enc="js">", _sDefaultBookmarkName);
}

function sGetDefaultToolbarButtons(vsDefaultBookmarkName, vsAdditionalToolbarHTML)
{
  if ((typeof(sGetBookmarkButton) != "undefined") && (typeof(sGetAddToBasketButton) != "undefined"))
    return sGetBookmarkButton(vsDefaultBookmarkName) +
           sGetAddToBasketButton(vsDefaultBookmarkName) +
           (vsAdditionalToolbarHTML ? vsAdditionalToolbarHTML : "");
  else 
    return "";
}

function sGetActionsButton()
{
  var oMainView = oGetMainView();
  if (oMainView && oMainView.bIsLicensedActions())
    return sGetToolbarIconButtonHTMLForOpenInformationView("<#LocalizedText id="Actions">", "<#AttachURL>", "<#PortalImageFileLocation>icon_actions.png");
  else
    return "";
}

function sGetDefaultToolbarButtonsWithActions(vsDefaultBookmarkName, vsAdditionalToolbarHTML)
{
  return sGetDefaultToolbarButtons(vsDefaultBookmarkName, sGetActionsButton() + (vsAdditionalToolbarHTML ? vsAdditionalToolbarHTML : ""));
}

var DATE_FIELDS = ["createddate", "lastmodifieddate", "approveddate", "startdate", "deadline", "identified", "validfrom", "validto", "datestamp"];
var DATE_FORMAT = "d.m.yy";

function initializeQuickFilter() {
  var selector = "";
  if ($("#ResizableTableHead th > div").size() > 0) { //some headers uses div, some don't
    selector = " > div";
  }
  $("#ResizableTableHead th" + selector).each(function() {
	if ($(this).children().size() == 0) {
	  var headerText = $(this).text();
	  $(this).text("");
	  $(this).append ("<span>" + headerText + "</span>");
	}
	$(this).append("<img class=\"addfiltericon\" alt=\"<#LocalizedText id="Add quick filter">\" src=\"<#PortalImageFileLocation>filter_add_icon.png\"></img>" +
	"<img class=\"removefiltericon\" style=\"display:none;\" alt=\"<#LocalizedText id="Remove quick filter">\" src=\"<#PortalImageFileLocation>filter_delete_icon.png\"></img>");
	var sortField = $(this).children("a").attr("href");
	if (sortField != null && sortField.indexOf("'") > -1) {
	  sortField = sortField.substring(sortField.indexOf("'") + 1);
	  sortField = sortField.substring(0, sortField.indexOf("'")).toLowerCase();
	}
	if ($.inArray(sortField, DATE_FIELDS) == -1) {
	  $(this).append("<input class=\"quickfilterinput\" style=\"display:none;\" type=\"text\"></input>");
	  $(this).attr("searchtype", "text");
	} else {
	  $(this).append("<input title=\"\" class=\"quickfilterstartdate\" style=\"display:none;\" type=\"text\"><span style=\"display:none;\">-</span></input><input title=\"\" class=\"quickfilterenddate\" style=\"display:none;\" type=\"text\"></input>");
	  $(this).attr("searchtype", "date");
	}
  });
  $("#ResizableTableHead .addfiltericon").click(addFilterIconClicked);
  $("#ResizableTableHead .removefiltericon").click(removeFilterIconClicked);
  $("#ResizableTableHead .quickfilterinput").keyup(quickFilterInputted);
  $("#ResizableTableHead .quickfilterstartdate, #ResizableTableHead .quickfilterenddate").change(quickFilterInputted);
  $(".quickfilterstartdate,.quickfilterenddate").datepicker({
	dateFormat: DATE_FORMAT,
	monthNames: ["Tammikuu", "Helmikuu", "Maaliskuu", "Huhtikuu", "Toukokuu", "Kes&auml;kuu", "Hein&auml;kuu", "Elokuu", "Syyskuu", "Lokakuu", "Marraskuu", "Joulukuu"],
	monthNamesShort: ["Tammikuu", "Helmikuu", "Maaliskuu", "Huhtikuu", "Toukokuu", "Kes&auml;kuu", "Hein&auml;kuu", "Elokuu", "Syyskuu", "Lokakuu", "Marraskuu", "Joulukuu"],
	dayNames: ["Sunnuntai", "Maanantai", "Tiistai", "Keskiviikko", "Torstai", "Perjantai", "Lauantai"],
	dayNamesMin: ["Su", "Ma", "Ti", "Ke", "To", "Pe", "La"],
	firstDay: 1,
	showWeek: true,
	weekHeader: "",
	showOtherMonths: true,
	changeMonth: true,
    changeYear: true,
	yearRange: "-10:+3"
  });
}
  
function addFilterIconClicked(source) {
  $(source.target).hide();
  $(source.target).nextAll().show();
  $(source.target).next().next().focus();
}
  
function removeFilterIconClicked(source) {
  $(source.target).hide();
  $(source.target).nextAll().hide();
  if ($(this).parent().attr("searchtype") == "text") {
    $(source.target).next().val("");
	$(source.target).next().attr("title", "");
  } else if ($(this).parent().attr("searchtype") == "date") {
    $(source.target).next().datepicker("setDate", null);
	$(source.target).next().attr("title", "");
	$(source.target).next().next().next().datepicker("setDate", null);
	$(source.target).next().next().next().attr("title", "");
  }
  $(source.target).prev().show();
  quickFilterInputted();
}
  
function quickFilterInputted(source) {
  if (source != null) $(source.target).attr("title", $(source.target).val());
  var numberOfColumns = $("#ResizableTableHead th").size();
  var searchData = new Array();
  $("#ResizableTableHead .addfiltericon").each(function() {
    var searchDataItem = new Object();
    searchData.push(searchDataItem);
    searchDataItem.searchtype = $(this).parent().attr("searchtype");
    if (searchDataItem.searchtype == "text") {
      searchDataItem.searchtext = $(this).next().next().val().toLowerCase();
	} else if (searchDataItem.searchtype == "date") {
      searchDataItem.startdate = $(this).next().next().datepicker("getDate");
      searchDataItem.enddate = $(this).next().next().next().next().datepicker("getDate");
    } else {
      throw "Unknown search type.";
    }
  });
  
  var columnWidths = new Array();
  $("#ResizableTableBody > tbody > tr:first > td").each(function() {
    columnWidths.push($(this).attr("style"));
  });
  
  var firstShownRow = true;
  $("#ResizableTableBody > tbody > tr").each(function() { //loop table rows
	var columnIndex = 0;
	$(this).children().each(function() { //loop row cells
	  if (searchData[columnIndex].searchtype == "text") {
	    var searchText = searchData[columnIndex].searchtext;
        if (searchText != null && searchText != "" && $(this).text().toLowerCase().indexOf(searchText) == -1) {
	      $(this).parent().hide();
	      return false;
		}
	  } else if (searchData[columnIndex].searchtype == "date") {
	    var contentAsDate = $(this).text();
		contentAsDate = $.datepicker.parseDate(DATE_FORMAT, contentAsDate);
		if ((searchData[columnIndex].startdate != null && (contentAsDate == null || contentAsDate < searchData[columnIndex].startdate)) || (searchData[columnIndex].enddate != null && (contentAsDate == null || contentAsDate > searchData[columnIndex].enddate))) {
		  $(this).parent().hide();
	      return false;
		}
	  }
	  columnIndex++;
	});
	
	if (columnIndex == numberOfColumns) { //any filter didn't set hidden
	  $(this).show();
	  if (firstShownRow) {
	    var index = 0;
	    $(this).children().each(function() {
		  if (columnWidths[index] != null) {
            $(this).attr("style", columnWidths[index]);
		  }
		  index++;
        });
	    firstShownRow = false;
	  }
	}
  });
  $(window).resize();
}
  
function resizeQuickFilterTextBoxes() {
  $("#ResizableTableHead .quickfilterinput").each(function() { //text input columns
    var width = $(this).parent().width() - $(this).prev().prev().prev().width() - 32;
	if (width > 5 && $(this).css("display") == "none") { //enough space for input box, and textbox not visible
	  $(this).width(width);
	  $(this).prev().prev().show();
	} else if (width > 5) { //enough space for input box, and textbox is visible
	  $(this).width(width);
	} else if ($(this).css("display") == "none") { //not enough space for input box, and textbox not visible
	  $(this).prev().prev().hide();
	} else { //not enough space for input box, and textbox is visible
      $(this).hide();
	  $(this).prev().hide();
	  $(this).prev().prev().hide();
	  $(this).val("");
	  $(this).attr("title", "");
      quickFilterInputted();
	}
  });
  $("#ResizableTableHead .quickfilterstartdate").each(function() { //date input columns
    var width = $(this).parent().width() - $(this).prev().prev().prev().width() - 32;
	var fieldWidth = (width - 7) / 2;
	if (width > 5 && $(this).css("display") == "none") { //enough space for input box, and textboxes not visible
	  $(this).width(fieldWidth);
	  $(this).next().next().width(fieldWidth);
	  $(this).prev().prev().show();
	} else if (width > 5) { //enough space for input box, and textboxes is visible
	  $(this).width(fieldWidth);
	  $(this).next().next().width(fieldWidth);
	} else if ($(this).css("display") == "none") { //not enough space for input box, and textboxes not visible
	  $(this).prev().prev().hide();
	} else { //not enough space for input box, and textboxes is visible
      $(this).hide();
	  $(this).next().hide();
	  $(this).next().next().hide();
	  $(this).prev().hide();
	  $(this).prev().prev().hide();
	  $(this).val("");
	  $(this).attr("title", "");
	  $(this).next().next().val("");
	  $(this).next().next().attr("title", "");
      quickFilterInputted();
	}
  });
}
  
</script>
<!-- [QPRTemplateEnd: jsportaltoolbarutils.tpl] -->
